"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.addPlugin = void 0;
const generated_1 = require("../generated");
const plugins_1 = require("../plugins");
const addPlugin = (context, { plugin, ...args }) => {
    if ((0, plugins_1.isExternalPluginAdapterType)(plugin)) {
        return (0, generated_1.addExternalPluginAdapterV1)(context, {
            ...args,
            initInfo: (0, plugins_1.createExternalPluginAdapterInitInfo)(plugin),
        });
    }
    const pair = (0, plugins_1.pluginAuthorityPairV2)(plugin);
    return (0, generated_1.addPluginV1)(context, {
        ...args,
        plugin: pair.plugin,
        initAuthority: pair.authority,
    });
};
exports.addPlugin = addPlugin;
//# sourceMappingURL=addPlugin.js.map