import { Context } from '@metaplex-foundation/umi';
import { CollectionV1, burnV1, AssetV1 } from '../generated';
export type BurnArgs = Omit<Parameters<typeof burnV1>[1], 'asset' | 'collection'> & {
    asset: Pick<AssetV1, 'publicKey' | 'owner' | 'oracles' | 'lifecycleHooks'>;
    collection?: Pick<CollectionV1, 'publicKey' | 'oracles' | 'lifecycleHooks'>;
};
export declare const burn: (context: Pick<Context, 'payer' | 'programs' | 'eddsa' | 'identity'>, { asset, collection, ...args }: BurnArgs) => import("@metaplex-foundation/umi").TransactionBuilder;
