"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.burn = void 0;
const generated_1 = require("../generated");
const plugins_1 = require("../plugins");
const helpers_1 = require("../helpers");
const burn = (context, { asset, collection, ...args }) => {
    const derivedExternalPluginAdapters = (0, helpers_1.deriveExternalPluginAdapters)(asset, collection);
    const extraAccounts = (0, plugins_1.findExtraAccounts)(context, 'burn', derivedExternalPluginAdapters, {
        asset: asset.publicKey,
        collection: collection?.publicKey,
        owner: asset.owner,
    });
    return (0, generated_1.burnV1)(context, {
        ...args,
        asset: asset.publicKey,
        collection: collection?.publicKey,
    }).addRemainingAccounts(extraAccounts);
};
exports.burn = burn;
//# sourceMappingURL=burn.js.map