"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.addCollectionPlugin = void 0;
const generated_1 = require("../../generated");
const plugins_1 = require("../../plugins");
const externalPluginAdapters_1 = require("../../plugins/externalPluginAdapters");
const addCollectionPlugin = (context, { plugin, ...args }) => {
    if ((0, externalPluginAdapters_1.isExternalPluginAdapterType)(plugin)) {
        return (0, generated_1.addCollectionExternalPluginAdapterV1)(context, {
            ...args,
            initInfo: (0, externalPluginAdapters_1.createExternalPluginAdapterInitInfo)(plugin),
        });
    }
    const pair = (0, plugins_1.pluginAuthorityPairV2)(plugin);
    return (0, generated_1.addCollectionPluginV1)(context, {
        ...args,
        plugin: pair.plugin,
        initAuthority: pair.authority,
    });
};
exports.addCollectionPlugin = addCollectionPlugin;
//# sourceMappingURL=addCollectionPlugin.js.map