"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createCollection = void 0;
const generated_1 = require("../../generated");
const plugins_1 = require("../../plugins");
const externalPluginAdapters_1 = require("../../plugins/externalPluginAdapters");
const createCollection = (context, { plugins, ...args }) => {
    const firstPartyPlugins = [];
    const externalPluginAdapters = [];
    plugins?.forEach((plugin) => {
        if ((0, externalPluginAdapters_1.isExternalPluginAdapterType)(plugin)) {
            externalPluginAdapters.push(plugin);
        }
        else {
            firstPartyPlugins.push(plugin);
        }
    });
    return (0, generated_1.createCollectionV2)(context, {
        ...args,
        plugins: firstPartyPlugins.map(plugins_1.pluginAuthorityPairV2),
        externalPluginAdapters: externalPluginAdapters.map(plugins_1.createExternalPluginAdapterInitInfo),
    });
};
exports.createCollection = createCollection;
//# sourceMappingURL=createCollection.js.map