"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.removeCollectionPlugin = void 0;
const generated_1 = require("../../generated");
const plugins_1 = require("../../plugins");
const externalPluginAdapters_1 = require("../../plugins/externalPluginAdapters");
const removeCollectionPlugin = (context, { plugin, ...args }) => {
    if ((0, externalPluginAdapters_1.isExternalPluginAdapterType)(plugin)) {
        return (0, generated_1.removeCollectionExternalPluginAdapterV1)(context, {
            ...args,
            key: (0, plugins_1.externalPluginAdapterKeyToBase)(plugin),
        });
    }
    return (0, generated_1.removeCollectionPluginV1)(context, {
        ...args,
        pluginType: generated_1.PluginType[plugin.type],
    });
};
exports.removeCollectionPlugin = removeCollectionPlugin;
//# sourceMappingURL=removeCollectionPlugin.js.map