"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.removePlugin = void 0;
const generated_1 = require("../generated");
const plugins_1 = require("../plugins");
const externalPluginAdapterKey_1 = require("../plugins/externalPluginAdapterKey");
const removePlugin = (context, { plugin, ...args }) => {
    if ((0, plugins_1.isExternalPluginAdapterType)(plugin)) {
        return (0, generated_1.removeExternalPluginAdapterV1)(context, {
            ...args,
            key: (0, externalPluginAdapterKey_1.externalPluginAdapterKeyToBase)(plugin),
        });
    }
    return (0, generated_1.removePluginV1)(context, {
        ...args,
        pluginType: generated_1.PluginType[plugin.type],
    });
};
exports.removePlugin = removePlugin;
//# sourceMappingURL=removePlugin.js.map