import { Context } from '@metaplex-foundation/umi';
import { CollectionV1, transferV1, AssetV1 } from '../generated';
export type TransferArgs = Omit<Parameters<typeof transferV1>[1], 'asset' | 'collection'> & {
    asset: Pick<AssetV1, 'publicKey' | 'owner' | 'oracles' | 'lifecycleHooks'>;
    collection?: Pick<CollectionV1, 'publicKey' | 'oracles' | 'lifecycleHooks'>;
};
export declare const transfer: (context: Pick<Context, 'payer' | 'programs' | 'eddsa' | 'identity'>, { asset, collection, ...args }: TransferArgs) => import("@metaplex-foundation/umi").TransactionBuilder;
