"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.transfer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const generated_1 = require("../generated");
const plugins_1 = require("../plugins");
const helpers_1 = require("../helpers");
const transfer = (context, { asset, collection, ...args }) => {
    const derivedExternalPluginAdapters = (0, helpers_1.deriveExternalPluginAdapters)(asset, collection);
    const extraAccounts = (0, plugins_1.findExtraAccounts)(context, 'transfer', derivedExternalPluginAdapters, {
        asset: asset.publicKey,
        collection: collection?.publicKey,
        owner: asset.owner,
        recipient: (0, umi_1.publicKey)(args.newOwner),
    });
    return (0, generated_1.transferV1)(context, {
        ...args,
        asset: asset.publicKey,
        collection: collection?.publicKey,
    }).addRemainingAccounts(extraAccounts);
};
exports.transfer = transfer;
//# sourceMappingURL=transfer.js.map