"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.update = void 0;
const generated_1 = require("../generated");
const plugins_1 = require("../plugins");
const helpers_1 = require("../helpers");
const update = (context, { asset, collection, name, uri, ...args }) => {
    const derivedExternalPluginAdapters = (0, helpers_1.deriveExternalPluginAdapters)(asset, collection);
    const extraAccounts = (0, plugins_1.findExtraAccounts)(context, 'update', derivedExternalPluginAdapters, {
        asset: asset.publicKey,
        collection: collection?.publicKey,
        owner: asset.owner,
    });
    return (0, generated_1.updateV1)(context, {
        ...args,
        asset: asset.publicKey,
        collection: collection?.publicKey,
        newName: name,
        newUri: uri,
    }).addRemainingAccounts(extraAccounts);
};
exports.update = update;
//# sourceMappingURL=update.js.map