"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.updatePlugin = void 0;
const generated_1 = require("../generated");
const plugins_1 = require("../plugins");
const updatePlugin = (context, { plugin, ...args }) => {
    if ((0, plugins_1.isExternalPluginAdapterType)(plugin)) {
        const plug = plugin;
        return (0, generated_1.updateExternalPluginAdapterV1)(context, {
            ...args,
            updateInfo: (0, plugins_1.createExternalPluginAdapterUpdateInfo)(plug),
            key: (0, plugins_1.externalPluginAdapterKeyToBase)(plug.key),
        });
    }
    return (0, generated_1.updatePluginV1)(context, {
        ...args,
        plugin: (0, plugins_1.createPluginV2)(plugin),
    });
};
exports.updatePlugin = updatePlugin;
//# sourceMappingURL=updatePlugin.js.map