import { PublicKey } from '@metaplex-foundation/umi';
import { BaseRoyalties, BaseRuleSet } from '../generated';
import { BasePlugin } from './types';
export type UnwrappedRuleSet = {
    type: 'None';
} | {
    type: 'ProgramAllowList';
    addresses: PublicKey[];
} | {
    type: 'ProgramDenyList';
    addresses: PublicKey[];
};
export type RuleSet = UnwrappedRuleSet | BaseRuleSet;
export type Royalties = Omit<BaseRoyalties, 'ruleSet'> & {
    ruleSet: RuleSet;
};
export type RoyaltiesArgs = Royalties;
export type RoyaltiesPlugin = BasePlugin & Royalties;
export declare function ruleSetToBase(r: RuleSet): BaseRuleSet;
export declare function royaltiesToBase(r: Royalties): BaseRoyalties;
export declare function royaltiesFromBase(r: BaseRoyalties): Royalties;
