"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.unwrapOption = exports.someOrNone = exports.lowercaseFirstLetter = exports.capitalizeFirstLetter = exports.toWords = void 0;
const umi_1 = require("@metaplex-foundation/umi");
function toWords(str) {
    const camelCaseRegex = /([a-z0-9])([A-Z])/g;
    return str.replace(camelCaseRegex, '$1 $2');
}
exports.toWords = toWords;
function capitalizeFirstLetter(str) {
    return str.charAt(0).toUpperCase() + str.slice(1);
}
exports.capitalizeFirstLetter = capitalizeFirstLetter;
function lowercaseFirstLetter(str) {
    return str.charAt(0).toLowerCase() + str.slice(1);
}
exports.lowercaseFirstLetter = lowercaseFirstLetter;
function someOrNone(value) {
    return value !== undefined ? (0, umi_1.some)(value) : (0, umi_1.none)();
}
exports.someOrNone = someOrNone;
function unwrapOption(value) {
    return value.__option === 'Some' ? value.value : undefined;
}
exports.unwrapOption = unwrapOption;
//# sourceMappingURL=utils.js.map